from struct import pack, unpack
import socket

def db(v):
  return pack("<B", v)

def dw(v):
  return pack("<H", v)

def dd(v):
  return pack("<I", v)

def dq(v):
  return pack("<Q", v)

def rb(v):
  return unpack("<B", v[0])[0]

def rw(v):
  return unpack("<H", v[:2])[0]

def rd(v):
  return unpack("<I", v[:4])[0]

def rq(v):
  return unpack("<Q", v[:8])[0]

def recvall(sock, n):
  d = []
  total_length = 0
  while total_length != n:
    try:
      dnow = sock.recv(n - len(d))
      if len(dnow) == 0:
        return False
    except socket.timeout:
      return False
    except socket.error as msg:
      return False
    d.append(dnow)
    total_length += len(dnow)
  return ''.join(d)


